package com.sky.ioc.service.security.impl;

import com.sky.ioc.entity.domain.security.SecurityDoor;
import com.sky.ioc.entity.domain.security.SecurityDoorRecord;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.mapper.security.SecurityDoorMapper;
import com.sky.ioc.mapper.security.SecurityDoorRecordMapper;
import com.sky.ioc.service.security.SecurityDoorRecordService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

@Service
@Slf4j
public class SecurityDoorRecordServiceImpl implements SecurityDoorRecordService {
    @Autowired
    TokenMapper tokenMapper;

    @Value("${sky.dataIp}")
    private String dataIp;

    @Autowired
    SecurityDoorRecordMapper securityDoorRecordMapper;

    final static  String SECURITY_DOOR_RECORD_URL="%s/api/safety/Hikvision/record/list";
    @Override
    public ReturnMsg getSecurityDoorRecordData() {
        String url =   String.format(SECURITY_DOOR_RECORD_URL,"http://"+dataIp)+"?pageNum=1&pageSize=1000";
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        HttpHeaders httpHeaders = new HttpHeaders();
        httpHeaders.set("authorization", token);
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<Map> responseEntity = restTemplate.exchange(url, HttpMethod.GET, httpEntity, Map.class);
        Map<String, Object> body = responseEntity.getBody();
        Integer code = (Integer)body.get("code");
        String message = (String)body.get("msg");
        if(code==200){
            ThreadLocalRandom random = ThreadLocalRandom.current();
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                securityDoorRecordMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    SecurityDoorRecord securityDoorRecord = new SecurityDoorRecord();
                    securityDoorRecord.setId((Integer) json.get("id"));
                    if(json.get("employeeName")!=null){
                        securityDoorRecord.setName(String.valueOf(json.get("employeeName")));
                    }

                    securityDoorRecord.setTime(String.valueOf(json.get("eventTime")));
                    securityDoorRecord.setDoorId(Integer.parseInt(String.valueOf(json.get("doorId"))));
                    securityDoorRecord.setInOutType(String.valueOf(json.get("inAndOutType")));
                    securityDoorRecord.setType(String.valueOf(json.get("eventType")));
                    securityDoorRecordMapper.insert(securityDoorRecord);
                }
            }
            return ReturnMsg.ok();

        }else{
            log.info("获取门禁记录数据："+message);
            return  ReturnMsg.fail(message);
        }
    }
}
